//FRAGMENT SHADER 

#extension GL_EXT_shadow_samplers : require

// inputs
uniform sampler2DShadow shadow_map; // the shadow map texture
varying highp vec4 v_shadowMapCoordinate;

uniform highp float shadowAlpha;

varying highp float isBelowPlane;

varying mediump float zValue;


void main()
{
    mediump vec4 shadow = vec4(0.0, 0.0, 0.0, shadowAlpha);
    
    if(isBelowPlane < 0.0)
    {
        discard;
    }
    
    mediump float depthFade = clamp(1.0 - ((-zValue - 7.0) / 150.0), 0.0, 1.0);
    
    //shadow.r = depthFade;
    
    shadow.a = shadow.a * depthFade;
    
    gl_FragColor = shadow;
}