//VERTEX SHADER 

// inputs
attribute vec4 vertexAttribPosition;
uniform highp mat4 modelViewTransform;
uniform highp mat4 projectionViewTransform;

uniform highp mat4 shadowProjectionMVP;

uniform highp vec3 lightPosition;

// outputs (varyings for fragment shader)
varying highp vec4 v_shadowMapCoordinate;

uniform highp float shadowPlaneDistance;
varying highp float isBelowPlane;

varying mediump float zValue;

void main()
{
    highp vec4 modelPosition = vertexAttribPosition;
    modelPosition = modelViewTransform * modelPosition;
    
    isBelowPlane = modelPosition.y - shadowPlaneDistance;
    
    //modelPosition = shadowProjectionMVP * modelPosition;
    
    
    mediump vec3 lightDirection = lightPosition - modelPosition.xyz;
    lightDirection.y = max(lightDirection.y, 1E-7); // make sure the light direction is at least slightly down
    mediump float multiplier = (modelPosition.y - shadowPlaneDistance) / (-lightDirection.y);

    modelPosition.xyz = modelPosition.xyz + (lightDirection * multiplier);
    
    zValue = modelPosition.z * modelPosition.w;
    
    // set the position of the vertex (no transform, these are flat)
    gl_Position = projectionViewTransform * modelPosition;
}