#extension GL_EXT_shader_framebuffer_fetch : require

uniform lowp sampler2D texture;

uniform lowp float drawBlueValue;

uniform lowp float brushAlpha;

varying highp vec2 v_textureCoordinate;
varying highp vec2 v_lastStrokeTextureCoordinate;

void main()
{
	highp vec4 textureColor = texture2D(texture, v_textureCoordinate);
    highp vec4 lastTextureColor = texture2D(texture, v_lastStrokeTextureCoordinate);
    
    
    highp float destValue = lastTextureColor.a * brushAlpha;
    highp float outputValue = textureColor.a * brushAlpha;
    
    // make the output value correct for glBlendFunc(GL_ONE_MINUS_DST_COLOR, GL_ONE)
    outputValue = (outputValue - destValue) / (1.0 - destValue);
    
    
    //textureColor.a = lastTextureColor.a * brushAlpha;
    
    // draw to the red or blue channel
    gl_FragColor = vec4(clamp((1.0 - drawBlueValue) * outputValue, 0.0, 1.0),
                        0.0,
                        clamp(drawBlueValue * outputValue, 0.0, 1.0),
                        1.0);
    
    
    /*
	lowp vec4 textureColor = texture2D(texture, v_textureCoordinate);
    //mediump vec4 lastTextureColor = texture2D(texture, v_lastStrokeTextureCoordinate);
    
    lowp vec4 preBrushTexelColor = gl_LastFragData[0]; // this fetches current framebuffer pixel value (used to make transparent brushes not write over themseleves)
    
    lowp float brushValue = textureColor.a * erasingMultiplier;
    
    //outputAlpha = textureColor * brushAlpha;
    
    lowp float currentMaskValue = mix(preBrushTexelColor.r, preBrushTexelColor.b, drawBlueValue); // use the green or alpha value to start with since we're drawing to the red or blue channel
    lowp float newMaskValue = mix(preBrushTexelColor.g, preBrushTexelColor.a, drawBlueValue);
    newMaskValue = mix(newMaskValue,
                   clamp(newMaskValue + brushValue, 0.0, 1.0), // clamp the possible future color value
                   brushAlpha); // mix it with the current color value using the brush alpha
    
 
    newMaskValue = max(currentMaskValue * erasingMultiplier, newMaskValue * erasingMultiplier) * erasingMultiplier;
    
    gl_FragColor = vec4(mix(newMaskValue, preBrushTexelColor.r, drawBlueValue) ,
                        preBrushTexelColor.g,
                        mix(preBrushTexelColor.b, newMaskValue, drawBlueValue),
                        preBrushTexelColor.a);
*/
}
